Request and response schemas
Field tables describe JSON input and output. Endpoint-specific requirements take precedence: some fields are assigned from your credentials or the URL. PATCH accepts partial input where documented. Read-only fields are output-only; write-only fields are omitted from responses. Example IDs and credentials are placeholders.
Use these schemas with the operation reference; a schema alone does not define authentication or which fields an operation accepts.
User
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
id | UUID string | Output only | allow_null: false |
email | email string | Required | allow_null: false; allow_blank: false; max_length: 254 |
password | string | Optional; input only | allow_null: false; allow_blank: false |
confirm_password | string | Optional; input only | allow_null: false; allow_blank: false |
first_name | string | Required | allow_null: false; allow_blank: false; max_length: 30 |
last_name | string | Required | allow_null: false; allow_blank: false; max_length: 30 |
company | string | Optional | allow_null: true; allow_blank: true; max_length: 100 |
website | URL string | Optional | allow_null: true; allow_blank: true; max_length: 200 |
country | string | Optional | allow_null: true; allow_blank: true; max_length: 100 |
job_title | string | Optional | allow_null: true; allow_blank: true; max_length: 100 |
phone_number | string | Optional | allow_null: true; allow_blank: true; max_length: 20 |
email_verified | boolean | Output only | allow_null: false |
created_at | date-time string | Output only | allow_null: false |
updated_at | date-time string | Output only | allow_null: false |
last_login | date-time string | Output only | allow_null: true |
created_via_api_key | string | Optional | allow_null: true; allow_blank: true; max_length: 64 |
developer_id | string | Optional | allow_null: true; allow_blank: true; max_length: 40 |
workspace | resource ID | Optional | allow_null: true |
oauth_client | OAuthClientByClientId | Optional | allow_null: true |
Response shape example:
{
"id": "11111111-1111-4111-8111-111111111111",
"email": "[email protected]",
"first_name": "Example",
"last_name": "Example",
"company": "EXAMPLE_COMPANY",
"website": "https://app.example.test/callback",
"country": "EXAMPLE_COUNTRY",
"job_title": "EXAMPLE_JOB_TITLE",
"phone_number": "EXAMPLE_PHONE_NUMBER",
"email_verified": true,
"created_at": "2026-10-26T12:00:00Z",
"updated_at": "2026-10-26T12:00:00Z",
"last_login": "2026-10-26T12:00:00Z",
"created_via_api_key": "EXAMPLE_CREATED_VIA_API_KEY",
"developer_id": "EXAMPLE_DEVELOPER_ID",
"workspace": "11111111-1111-4111-8111-111111111111",
"oauth_client": "11111111-1111-4111-8111-111111111111"
}
Group
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
id | UUID string | Output only | allow_null: false |
name | string | Required | allow_null: false; allow_blank: false; min_length: 3; max_length: 255 |
created_at | date-time string | Output only | allow_null: false |
updated_at | date-time string | Output only | allow_null: false |
created_via_api_key | string | Optional | allow_null: true; allow_blank: true; max_length: 64 |
developer_id | string | Optional | allow_null: true; allow_blank: true; max_length: 40 |
workspace | resource ID | Required | allow_null: false |
member_count | computed value | Output only | allow_null: false |
Response shape example:
{
"id": "11111111-1111-4111-8111-111111111111",
"name": "Example",
"created_at": "2026-10-26T12:00:00Z",
"updated_at": "2026-10-26T12:00:00Z",
"created_via_api_key": "EXAMPLE_CREATED_VIA_API_KEY",
"developer_id": "EXAMPLE_DEVELOPER_ID",
"workspace": "11111111-1111-4111-8111-111111111111",
"member_count": 1
}
GroupMember
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
user_id | UUID string | Required; input only | allow_null: false |
group_id | UUID string | Required; input only | allow_null: false |
Response shape example:
{}
OAuthClient
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
id | UUID string | Output only | allow_null: false |
name | string | Required | allow_null: false; allow_blank: false; min_length: 3; max_length: 255 |
client_id | string | Output only | allow_null: false; allow_blank: false |
client_secret | computed value | Output only | allow_null: false |
client_type | string | Optional | allow_null: false; allow_blank: false; choices: ["confidential", "public"] |
redirect_uris | array | Required | allow_null: false; allow_blank: false |
allowed_grant_types | array | Required | allow_null: false; allow_blank: false; max_length: 255 |
allowed_response_types | array | Required | allow_null: false; allow_blank: false; max_length: 100 |
allowed_scopes | array | Required | allow_null: false; allow_blank: false; max_length: 255 |
auto_approve | boolean | Optional | allow_null: false |
created_at | date-time string | Output only | allow_null: false |
updated_at | date-time string | Output only | allow_null: false |
is_active | boolean | Optional | allow_null: false |
developer_id | string | Optional | allow_null: true; allow_blank: true; max_length: 40 |
workspace | resource ID | Required | allow_null: false |
Response shape example:
{
"id": "11111111-1111-4111-8111-111111111111",
"name": "Example",
"client_id": "EXAMPLE_CLIENT_ID",
"client_secret": "***HIDDEN***",
"client_type": "confidential",
"redirect_uris": "http://127.0.0.1:8080/callback",
"allowed_grant_types": "authorization_code,refresh_token",
"allowed_response_types": "code",
"allowed_scopes": "openid,profile,email",
"auto_approve": true,
"created_at": "2026-10-26T12:00:00Z",
"updated_at": "2026-10-26T12:00:00Z",
"is_active": true,
"developer_id": "EXAMPLE_DEVELOPER_ID",
"workspace": "11111111-1111-4111-8111-111111111111"
}
PasswordResetRequest
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
email | email string | Required | allow_null: false; allow_blank: false |
Response shape example:
{
"email": "[email protected]"
}
EmailTemplate
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
id | UUID string | Output only | allow_null: false |
name | string | Required | allow_null: false; allow_blank: false; choices: ["reset_password", "registration_confirmation", "welcome", "email_verification", "workspace_invitation", "magic_link", "new_device_alert"] |
subject | string | Required | allow_null: false; allow_blank: false |
body | string | Required | allow_null: false; allow_blank: false |
html_content | computed value | Output only | allow_null: false |
created_at | date-time string | Output only | allow_null: false |
updated_at | date-time string | Output only | allow_null: false |
is_default | boolean | Output only | allow_null: false |
created_via_api_key | string | Optional | allow_null: true; allow_blank: true; max_length: 64 |
developer_id | string | Optional | allow_null: true; allow_blank: true; max_length: 40 |
workspace | resource ID | Required | allow_null: false |
Response shape example:
{
"id": "11111111-1111-4111-8111-111111111111",
"name": "reset_password",
"subject": "EXAMPLE_SUBJECT",
"body": "EXAMPLE_BODY",
"html_content": "EXAMPLE_HTML_CONTENT",
"created_at": "2026-10-26T12:00:00Z",
"updated_at": "2026-10-26T12:00:00Z",
"is_default": true,
"created_via_api_key": "EXAMPLE_CREATED_VIA_API_KEY",
"developer_id": "EXAMPLE_DEVELOPER_ID",
"workspace": "11111111-1111-4111-8111-111111111111"
}
PasswordResetConfirm
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
email | email string | Required | allow_null: false; allow_blank: false |
code | string | Required | allow_null: false; allow_blank: false |
new_password | string | Required | allow_null: false; allow_blank: false |
confirm_password | string | Required | allow_null: false; allow_blank: false |
Response shape example:
{
"email": "[email protected]",
"code": "EXAMPLE_CODE",
"new_password": "EXAMPLE_NEW_PASSWORD",
"confirm_password": "EXAMPLE_CONFIRM_PASSWORD"
}
VerifyEmail
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
email | email string | Required | allow_null: false; allow_blank: false |
code | string | Required | allow_null: false; allow_blank: false |
Response shape example:
{
"email": "[email protected]",
"code": "EXAMPLE_CODE"
}
ApiToken
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
id | UUID string | Output only | allow_null: false |
name | string | Required | allow_null: false; allow_blank: false; min_length: 3; max_length: 255 |
token | string | Output only | allow_null: false; allow_blank: false |
scope | string | Optional | allow_null: false; allow_blank: true |
created_at | date-time string | Output only | allow_null: false |
expires_at | date-time string | Optional | allow_null: true |
last_used_at | date-time string | Output only | allow_null: true |
is_active | boolean | Optional | allow_null: false |
created_via_api_key | string | Optional | allow_null: true; allow_blank: true; max_length: 64 |
developer_id | string | Optional | allow_null: true; allow_blank: true; max_length: 40 |
workspace | resource ID | Required | allow_null: false |
Response shape example:
{
"id": "11111111-1111-4111-8111-111111111111",
"name": "Example",
"token": "EXAMPLE_TOKEN",
"scope": "EXAMPLE_SCOPE",
"created_at": "2026-10-26T12:00:00Z",
"expires_at": "2026-10-26T12:00:00Z",
"last_used_at": "2026-10-26T12:00:00Z",
"is_active": true,
"created_via_api_key": "EXAMPLE_CREATED_VIA_API_KEY",
"developer_id": "EXAMPLE_DEVELOPER_ID",
"workspace": "11111111-1111-4111-8111-111111111111"
}
Login
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
email | email string | Required | allow_null: false; allow_blank: false |
password | string | Required | allow_null: false; allow_blank: false |
remember_me | boolean | Optional | allow_null: false; default: false |
Response shape example:
{
"email": "[email protected]",
"password": "EXAMPLE_PASSWORD",
"remember_me": false
}
ExternalProvider
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
id | UUID string | Output only | allow_null: false |
name | string | Required | allow_null: false; allow_blank: false; min_length: 3; max_length: 100 |
provider_type | string | Required | allow_null: false; allow_blank: false; choices: ["google", "linkedin", "facebook", "github"] |
client_id | string | Required | allow_null: false; allow_blank: false; max_length: 255 |
client_secret | string | Required; input only | allow_null: false; allow_blank: false |
client_secret_masked | computed value | Output only | allow_null: false |
is_active | boolean | Optional | allow_null: false |
created_at | date-time string | Output only | allow_null: false |
updated_at | date-time string | Output only | allow_null: false |
developer_id | string | Optional | allow_null: true; allow_blank: false |
workspace | resource ID | Required | allow_null: false |
Response shape example:
{
"id": "11111111-1111-4111-8111-111111111111",
"name": "Example",
"provider_type": "google",
"client_id": "EXAMPLE_CLIENT_ID",
"client_secret_masked": "EXAMPLE_CLIENT_SECRET_MASKED",
"is_active": true,
"created_at": "2026-10-26T12:00:00Z",
"updated_at": "2026-10-26T12:00:00Z",
"developer_id": "EXAMPLE_DEVELOPER_ID",
"workspace": "11111111-1111-4111-8111-111111111111"
}
OAuthClientBranding
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
id | UUID string | Output only | allow_null: false |
oauth_client | resource ID | Required | allow_null: false |
logo_url | string | Optional | allow_null: true; allow_blank: true |
company_name | string | Optional | allow_null: false; allow_blank: true; max_length: 255 |
primary_color | string | Optional | allow_null: false; allow_blank: false; max_length: 7 |
secondary_color | string | Optional | allow_null: false; allow_blank: false; max_length: 7 |
background_color | string | Optional | allow_null: false; allow_blank: false; max_length: 7 |
theme | string | Optional | allow_null: false; allow_blank: false; choices: ["light", "dark", "auto"] |
custom_css | string | Optional | allow_null: true; allow_blank: true |
show_social_logins | boolean | Optional | allow_null: false |
terms_url | URL string | Optional | allow_null: true; allow_blank: true; max_length: 500 |
privacy_url | URL string | Optional | allow_null: true; allow_blank: true; max_length: 500 |
created_at | date-time string | Output only | allow_null: false |
updated_at | date-time string | Output only | allow_null: false |
Response shape example:
{
"id": "11111111-1111-4111-8111-111111111111",
"oauth_client": "11111111-1111-4111-8111-111111111111",
"logo_url": "EXAMPLE_LOGO_URL",
"company_name": "EXAMPLE_COMPANY_NAME",
"primary_color": "EXAMPLE_PRIMARY_COLOR",
"secondary_color": "EXAMPLE_SECONDARY_COLOR",
"background_color": "EXAMPLE_BACKGROUND_COLOR",
"theme": "light",
"custom_css": "EXAMPLE_CUSTOM_CSS",
"show_social_logins": true,
"terms_url": "https://app.example.test/callback",
"privacy_url": "https://app.example.test/callback",
"created_at": "2026-10-26T12:00:00Z",
"updated_at": "2026-10-26T12:00:00Z"
}
Workspace
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
id | UUID string | Output only | allow_null: false |
name | string | Required | allow_null: false; allow_blank: false; min_length: 3; max_length: 255 |
owner_id | string | Output only | allow_null: false; allow_blank: false |
active_plan_id | UUID string | Output only | allow_null: true |
created_at | date-time string | Output only | allow_null: false |
updated_at | date-time string | Output only | allow_null: false |
is_active | boolean | Optional | allow_null: false |
member_count | computed value | Output only | allow_null: false |
Response shape example:
{
"id": "11111111-1111-4111-8111-111111111111",
"name": "Example",
"owner_id": "EXAMPLE_OWNER_ID",
"active_plan_id": "11111111-1111-4111-8111-111111111111",
"created_at": "2026-10-26T12:00:00Z",
"updated_at": "2026-10-26T12:00:00Z",
"is_active": true,
"member_count": 1
}
WorkspaceMember
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
id | UUID string | Output only | allow_null: false |
workspace | resource ID | Required | allow_null: false |
workspace_name | string | Output only | allow_null: false; allow_blank: false |
user_id | string | Required | allow_null: false; allow_blank: false; max_length: 40 |
role | string | Optional | allow_null: false; allow_blank: false; choices: ["owner", "member"] |
created_at | date-time string | Output only | allow_null: false |
Response shape example:
{
"id": "11111111-1111-4111-8111-111111111111",
"workspace": "11111111-1111-4111-8111-111111111111",
"workspace_name": "EXAMPLE_WORKSPACE_NAME",
"user_id": "EXAMPLE_USER_ID",
"role": "owner",
"created_at": "2026-10-26T12:00:00Z"
}
WorkspaceInvitation
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
id | UUID string | Output only | allow_null: false |
workspace | resource ID | Required | allow_null: false |
workspace_name | string | Output only | allow_null: false; allow_blank: false |
invited_user_id | string | Required | allow_null: false; allow_blank: false; max_length: 40 |
invited_user_email | computed value | Output only | allow_null: false |
invited_by_id | string | Output only | allow_null: false; allow_blank: false |
invited_by_email | computed value | Output only | allow_null: false |
role | string | Optional | allow_null: false; allow_blank: false; choices: ["owner", "member"] |
status | string | Output only | allow_null: false; allow_blank: false; choices: ["pending", "accepted", "rejected", "expired", "cancelled"] |
token | string | Output only | allow_null: false; allow_blank: false |
expires_at | date-time string | Output only | allow_null: false |
accepted_at | date-time string | Output only | allow_null: true |
rejected_at | date-time string | Output only | allow_null: true |
created_at | date-time string | Output only | allow_null: false |
updated_at | date-time string | Output only | allow_null: false |
message | string | Optional | allow_null: false; allow_blank: true |
is_expired | computed value | Output only | allow_null: false |
can_be_accepted | computed value | Output only | allow_null: false |
Response shape example:
{
"id": "11111111-1111-4111-8111-111111111111",
"workspace": "11111111-1111-4111-8111-111111111111",
"workspace_name": "EXAMPLE_WORKSPACE_NAME",
"invited_user_id": "EXAMPLE_INVITED_USER_ID",
"invited_user_email": "EXAMPLE_INVITED_USER_EMAIL",
"invited_by_id": "EXAMPLE_INVITED_BY_ID",
"invited_by_email": "EXAMPLE_INVITED_BY_EMAIL",
"role": "owner",
"status": "pending",
"token": "EXAMPLE_TOKEN",
"expires_at": "2026-10-26T12:00:00Z",
"accepted_at": "2026-10-26T12:00:00Z",
"rejected_at": "2026-10-26T12:00:00Z",
"created_at": "2026-10-26T12:00:00Z",
"updated_at": "2026-10-26T12:00:00Z",
"message": "EXAMPLE_MESSAGE",
"is_expired": true,
"can_be_accepted": "EXAMPLE_CAN_BE_ACCEPTED"
}
ExternalProviderConfig
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
provider_type | string | Required | allow_null: false; allow_blank: false; choices: ["google", "linkedin", "facebook", "github"] |
name | string | Required | allow_null: false; allow_blank: false; max_length: 100 |
client_id | string | Required | allow_null: false; allow_blank: false; max_length: 255 |
client_secret | string | Required | allow_null: false; allow_blank: false; max_length: 255 |
Response shape example:
{
"provider_type": "google",
"name": "Example",
"client_id": "EXAMPLE_CLIENT_ID",
"client_secret": "***HIDDEN***"
}
QuickBuildRequest
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
workspace | resource ID | Required | allow_null: false |
company_name | string | Required | allow_null: false; allow_blank: false; max_length: 255 |
admin_contact | email string | Required | allow_null: false; allow_blank: false |
application_name | string | Optional | allow_null: false; allow_blank: false; max_length: 255 |
auth_providers | array | Required | allow_null: false; items: {"type": "ChoiceField", "required": true, "read_only": false, "write_only": false, "allow_null": false, "allow_blank": false, "choices": ["email", "oauth"]} |
external_providers | array | Optional | allow_null: false |
redirect_uris | array | Required | allow_null: false; items: {"type": "URLField", "required": true, "read_only": false, "write_only": false, "allow_null": false, "allow_blank": false} |
allowed_scopes | string | Optional | allow_null: false; allow_blank: false; default: "openid,profile,email" |
Response shape example:
{
"workspace": "11111111-1111-4111-8111-111111111111",
"company_name": "EXAMPLE_COMPANY_NAME",
"admin_contact": "[email protected]",
"application_name": "EXAMPLE_APPLICATION_NAME",
"auth_providers": [
"email"
],
"external_providers": "EXAMPLE_EXTERNAL_PROVIDERS",
"redirect_uris": [
"https://app.example.test/callback"
],
"allowed_scopes": "openid,profile,email"
}
QuickBuildResponse
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
oauth_client | object / JSON | Required | allow_null: false |
api_tokens | array | Required | allow_null: false; items: {"type": "DictField", "required": true, "read_only": false, "write_only": false, "allow_null": false} |
email_templates | array | Required | allow_null: false; items: {"type": "DictField", "required": true, "read_only": false, "write_only": false, "allow_null": false} |
external_providers | array | Optional | allow_null: false; items: {"type": "DictField", "required": true, "read_only": false, "write_only": false, "allow_null": false} |
env_config | string | Required | allow_null: false; allow_blank: false |
Response shape example:
{
"oauth_client": {},
"api_tokens": [
{}
],
"email_templates": [
{}
],
"external_providers": [
{}
],
"env_config": "EXAMPLE_ENV_CONFIG"
}
CustomDatabaseConnection
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
id | UUID string | Output only | allow_null: false |
workspace | resource ID | Optional | allow_null: false |
name | string | Required | allow_null: false; allow_blank: false; min_length: 3; max_length: 255 |
description | string | Optional | allow_null: false; allow_blank: true |
database_type | string | Required | allow_null: false; allow_blank: false; choices: ["postgresql", "mysql", "mongodb", "mssql", "api"] |
sync_mode | string | Output only | allow_null: false; allow_blank: false |
connection_string | string | Optional; input only | allow_null: false; allow_blank: false |
connection_string_masked | computed value | Output only | allow_null: false |
connection_config | object / JSON | Optional | allow_null: false |
entities_config | object / JSON | Optional | allow_null: false |
schema_mapping | object / JSON | Optional | allow_null: false |
cache_ttl_seconds | integer | Optional | allow_null: false; min_value: -9223372036854775808; max_value: 9223372036854775807 |
is_active | boolean | Optional | allow_null: false |
connection_status | string | Output only | allow_null: false; allow_blank: false; choices: ["unknown", "healthy", "error", "testing"] |
last_connection_test | date-time string | Output only | allow_null: true |
last_connection_error | string | Output only | allow_null: false; allow_blank: false |
migration_started_at | date-time string | Output only | allow_null: true |
migration_completed_at | date-time string | Output only | allow_null: true |
migrated_users_count | integer | Output only | allow_null: false |
developer_id | string | Optional | allow_null: false; allow_blank: false; max_length: 40 |
scripts_count | computed value | Output only | allow_null: false |
created_at | date-time string | Output only | allow_null: false |
updated_at | date-time string | Output only | allow_null: false |
Response shape example:
{
"id": "11111111-1111-4111-8111-111111111111",
"workspace": "11111111-1111-4111-8111-111111111111",
"name": "Example",
"description": "EXAMPLE_DESCRIPTION",
"database_type": "postgresql",
"sync_mode": "EXAMPLE_SYNC_MODE",
"connection_string_masked": "EXAMPLE_CONNECTION_STRING_MASKED",
"connection_config": {},
"entities_config": {},
"schema_mapping": {},
"cache_ttl_seconds": 1,
"is_active": true,
"connection_status": "unknown",
"last_connection_test": "2026-10-26T12:00:00Z",
"last_connection_error": "EXAMPLE_LAST_CONNECTION_ERROR",
"migration_started_at": "2026-10-26T12:00:00Z",
"migration_completed_at": "2026-10-26T12:00:00Z",
"migrated_users_count": 1,
"developer_id": "EXAMPLE_DEVELOPER_ID",
"scripts_count": 1,
"created_at": "2026-10-26T12:00:00Z",
"updated_at": "2026-10-26T12:00:00Z"
}
CustomDatabaseScript
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
id | UUID string | Output only | allow_null: false |
connection | resource ID | Optional | allow_null: false |
script_type | string | Required | allow_null: false; allow_blank: false; choices: ["login", "create", "get_user", "get_user_by_id", "change_password", "delete", "verify", "change_email"] |
script_language | string | Optional | allow_null: false; allow_blank: false; choices: ["sql", "python"] |
script_content | string | Required | allow_null: false; allow_blank: false |
is_enabled | boolean | Optional | allow_null: false |
last_execution_at | date-time string | Output only | allow_null: true |
execution_count | integer | Output only | allow_null: false |
success_count | integer | Output only | allow_null: false |
error_count | integer | Output only | allow_null: false |
avg_execution_time_ms | number | Output only | allow_null: false |
success_rate | computed value | Output only | allow_null: false |
created_at | date-time string | Output only | allow_null: false |
updated_at | date-time string | Output only | allow_null: false |
Response shape example:
{
"id": "11111111-1111-4111-8111-111111111111",
"connection": "11111111-1111-4111-8111-111111111111",
"script_type": "login",
"script_language": "sql",
"script_content": "EXAMPLE_SCRIPT_CONTENT",
"is_enabled": true,
"last_execution_at": "2026-10-26T12:00:00Z",
"execution_count": 1,
"success_count": 1,
"error_count": 1,
"avg_execution_time_ms": 1.0,
"success_rate": "EXAMPLE_SUCCESS_RATE",
"created_at": "2026-10-26T12:00:00Z",
"updated_at": "2026-10-26T12:00:00Z"
}
CustomDatabaseSyncLog
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
id | UUID string | Output only | allow_null: false |
connection | resource ID | Output only | allow_null: false |
connection_name | string | Output only | allow_null: false; allow_blank: false |
operation | string | Output only | allow_null: false; allow_blank: false; choices: ["login", "create", "get_user", "change_password", "delete", "verify", "change_email", "test_connection", "sync"] |
entity_type | string | Output only | allow_null: false; allow_blank: false |
entity_id | string | Output only | allow_null: false; allow_blank: false |
status | string | Output only | allow_null: false; allow_blank: false; choices: ["success", "error", "timeout"] |
error_message | string | Output only | allow_null: false; allow_blank: false |
error_code | string | Output only | allow_null: false; allow_blank: false |
execution_time_ms | integer | Output only | allow_null: false |
request_id | string | Output only | allow_null: false; allow_blank: false |
ip_address | IPAddress | Output only | allow_null: true; allow_blank: false |
created_at | date-time string | Output only | allow_null: false |
Response shape example:
{
"id": "11111111-1111-4111-8111-111111111111",
"connection": "11111111-1111-4111-8111-111111111111",
"connection_name": "EXAMPLE_CONNECTION_NAME",
"operation": "login",
"entity_type": "EXAMPLE_ENTITY_TYPE",
"entity_id": "EXAMPLE_ENTITY_ID",
"status": "success",
"error_message": "EXAMPLE_ERROR_MESSAGE",
"error_code": "EXAMPLE_ERROR_CODE",
"execution_time_ms": 1,
"request_id": "EXAMPLE_REQUEST_ID",
"ip_address": "EXAMPLE_IP_ADDRESS",
"created_at": "2026-10-26T12:00:00Z"
}
CustomDatabaseUserMapping
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
id | UUID string | Output only | allow_null: false |
connection | resource ID | Required | allow_null: false |
local_user_id | UUID string | Required | allow_null: false |
external_user_id | string | Required | allow_null: false; allow_blank: false; max_length: 255 |
is_migrated | boolean | Optional | allow_null: false |
last_synced_at | date-time string | Optional | allow_null: true |
sync_direction | string | Optional | allow_null: false; allow_blank: false; choices: ["to_external", "from_external", "bidirectional"] |
created_at | date-time string | Output only | allow_null: false |
updated_at | date-time string | Output only | allow_null: false |
Response shape example:
{
"id": "11111111-1111-4111-8111-111111111111",
"connection": "11111111-1111-4111-8111-111111111111",
"local_user_id": "11111111-1111-4111-8111-111111111111",
"external_user_id": "EXAMPLE_EXTERNAL_USER_ID",
"is_migrated": true,
"last_synced_at": "2026-10-26T12:00:00Z",
"sync_direction": "to_external",
"created_at": "2026-10-26T12:00:00Z",
"updated_at": "2026-10-26T12:00:00Z"
}
ConnectionTest
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
success | boolean | Output only | allow_null: false |
message | string | Output only | allow_null: false; allow_blank: false |
latency_ms | integer | Output only | allow_null: false |
Response shape example:
{
"success": true,
"message": "EXAMPLE_MESSAGE",
"latency_ms": 1
}
ScriptTest
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
email | email string | Optional | allow_null: false; allow_blank: false |
password | string | Optional; input only | allow_null: false; allow_blank: false |
user_id | string | Optional | allow_null: false; allow_blank: false |
success | boolean | Output only | allow_null: false |
result | object / JSON | Output only | allow_null: false |
execution_time_ms | integer | Output only | allow_null: false |
error | string | Output only | allow_null: true; allow_blank: false |
Response shape example:
{
"email": "[email protected]",
"user_id": "EXAMPLE_USER_ID",
"success": true,
"result": {},
"execution_time_ms": 1,
"error": "EXAMPLE_ERROR"
}
DeveloperAccessToken
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
id | UUID string | Output only | allow_null: false |
name | string | Required | allow_null: false; allow_blank: false; min_length: 3; max_length: 255 |
scopes | array | Required; input only | allow_null: false; items: {"type": "ChoiceField", "required": true, "read_only": false, "write_only": false, "allow_null": false, "allow_blank": false, "choices": ["api", "read_access_tokens", "write_access_tokens", "read_workspaces", "write_workspaces", "read_invitations", "write_invitations", "read_clients", "write_clients", "read_external_providers", "write_external_providers", "read_users", "write_users", "read_groups", "write_groups", "read_templates", "write_templates", "read_tokens", "write_tokens", "read_scim", "write_scim", "read_saml", "write_saml", "read_custom_databases", "write_custom_databases", "read_audit", "read_plans", "read_stats", "write_quick_build"]} |
scopes_display | computed value | Output only | allow_null: false |
token_prefix_display | string | Output only | allow_null: false; allow_blank: false |
expires_at | date-time string | Output only | allow_null: true |
expires_in_days | integer | Optional; input only | allow_null: true; min_value: 1; max_value: 365 |
last_used_at | date-time string | Output only | allow_null: true |
last_used_ip | IPAddress | Output only | allow_null: true; allow_blank: false |
created_at | date-time string | Output only | allow_null: false |
is_active | boolean | Output only | allow_null: false |
is_expired | computed value | Output only | allow_null: false |
Response shape example:
{
"id": "11111111-1111-4111-8111-111111111111",
"name": "Example",
"scopes_display": [],
"token_prefix_display": "EXAMPLE_TOKEN_PREFIX_DISPLAY",
"expires_at": "2026-10-26T12:00:00Z",
"last_used_at": "2026-10-26T12:00:00Z",
"last_used_ip": "EXAMPLE_LAST_USED_IP",
"created_at": "2026-10-26T12:00:00Z",
"is_active": true,
"is_expired": true
}
AuditEvent
| Field | Type | Input requirement | Constraints |
|---|---|---|---|
id | UUID string | Output only | allow_null: false |
workspace_id | computed value | Output only | allow_null: false |
event_type | string | Output only | allow_null: false; allow_blank: false; choices: ["login_success", "login_failure", "logout", "register", "password_reset_request", "password_reset_confirm", "password_update", "email_verify_send", "email_verify_confirm", "oauth_client_create", "oauth_client_update", "oauth_client_delete", "oauth_client_secret_reset", "oauth_token_issue", "oauth_token_revoke", "oauth_consent_grant", "workspace_create", "workspace_update", "workspace_delete", "workspace_member_add", "workspace_member_remove", "workspace_invite_send", "workspace_invite_accept", "api_token_create", "api_token_revoke", "dev_token_create", "dev_token_revoke", "user_create", "user_update", "user_delete", "user_group_assign", "user_group_unassign", "external_provider_create", "external_provider_update", "external_provider_delete", "custom_db_connect", "custom_db_disconnect", "custom_db_sync_fail", "session_create", "session_revoke", "session_revoke_all", "magic_link_request", "magic_link_consume_success", "magic_link_consume_failure", "mfa_enroll_start", "mfa_enroll_confirm", "mfa_disable", "mfa_verify_success", "mfa_verify_failure", "webauthn_register_start", "webauthn_register_success", "webauthn_register_failure", "webauthn_authenticate_success", "webauthn_authenticate_failure", "scim_token_create", "scim_token_revoke", "scim_user_create", "scim_user_update", "scim_user_delete", "scim_group_create", "scim_group_update", "scim_group_delete", "saml_sp_create", "saml_sp_update", "saml_sp_delete", "saml_sso_success", "saml_sso_failure", "anomaly_detected", "anomaly_notified", "mfa_recovery_generate", "mfa_recovery_consume"] |
severity | string | Output only | allow_null: false; allow_blank: false; choices: ["info", "warn", "error"] |
actor_type | string | Output only | allow_null: false; allow_blank: false; choices: ["developer", "end_user", "api_token", "oauth_client", "system", "anonymous"] |
actor_id | string | Output only | allow_null: true; allow_blank: false |
actor_email | string | Output only | allow_null: true; allow_blank: false |
target_type | string | Output only | allow_null: true; allow_blank: false |
target_id | string | Output only | allow_null: true; allow_blank: false |
oauth_client_id | computed value | Output only | allow_null: false |
ip_address | IPAddress | Output only | allow_null: true; allow_blank: false |
user_agent | string | Output only | allow_null: false; allow_blank: false |
request_id | string | Output only | allow_null: true; allow_blank: false |
message | string | Output only | allow_null: false; allow_blank: false |
metadata | object / JSON | Output only | allow_null: false |
created_at | date-time string | Output only | allow_null: false |
Response shape example:
{
"id": "11111111-1111-4111-8111-111111111111",
"workspace_id": "EXAMPLE_WORKSPACE_ID",
"event_type": "login_success",
"severity": "info",
"actor_type": "developer",
"actor_id": "EXAMPLE_ACTOR_ID",
"actor_email": "EXAMPLE_ACTOR_EMAIL",
"target_type": "EXAMPLE_TARGET_TYPE",
"target_id": "EXAMPLE_TARGET_ID",
"oauth_client_id": "EXAMPLE_OAUTH_CLIENT_ID",
"ip_address": "EXAMPLE_IP_ADDRESS",
"user_agent": "EXAMPLE_USER_AGENT",
"request_id": "EXAMPLE_REQUEST_ID",
"message": "EXAMPLE_MESSAGE",
"metadata": {},
"created_at": "2026-10-26T12:00:00Z"
}